// Decompiled by Jad v1.5.8e2. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://kpdus.tripod.com/jad.html
// Decompiler options: packimports(3)
// Source File Name:   ForceDirectedLayout.java

package yWays.autolayout.beckerrojas.pathwayLayout;

import java.awt.geom.Rectangle2D;
import java.util.*;
import y.base.*;
import y.layout.LayoutGraph;
import y.module.LayoutModule;

// Referenced classes of package yWays.autolayout.beckerrojas.pathwayLayout:
//            Subgraph

public class ForceDirectedLayout extends LayoutModule
{
    class EdgeWrapper
    {

        Edge edge;
        NodeWrapper source;
        NodeWrapper target;
        double length;

        EdgeWrapper(Edge edge1, NodeWrapper nodewrapper, NodeWrapper nodewrapper1)
        {
            length = 0.0D;
            edge = edge1;
            source = nodewrapper;
            target = nodewrapper1;
        }
    }

    class NodeWrapper
    {

        Node node;
        double x;
        double y;
        double width;
        double height;
        double inertia;
        double dx;
        double dy;
        double cOfMDx;
        double cOfMDy;

        NodeWrapper(Node node1)
        {
            inertia = 1.0D;
            dx = 0.0D;
            dy = 0.0D;
            cOfMDx = 0.0D;
            cOfMDy = 0.0D;
            node = node1;
            x = ((LayoutGraph)node1.getGraph()).getCenterX(node1);
            y = ((LayoutGraph)node1.getGraph()).getCenterY(node1);
            width = ((LayoutGraph)node1.getGraph()).getWidth(node1);
            height = ((LayoutGraph)node1.getGraph()).getHeight(node1);
        }
    }


    public ForceDirectedLayout(LayoutGraph layoutgraph, Subgraph subgraph1)
    {
        super("ForceDirectedLayout", "Moritz Y. Becker", "edges as springs, repulsive nodes");
        defaultLength = 100D;
        iterations = 300;
        bounds = new java.awt.geom.Rectangle2D.Double(-5000D, -5000D, 10000D, 10000D);
        edgeTension = 0.0D;
        oldTension = 0.0D;
        g = layoutgraph;
        subgraph = subgraph1;
        NodeCursor nodecursor = subgraph1.nodes();
        Hashtable hashtable = new Hashtable();
        nodecursor.toFirst();
        for(; nodecursor.ok(); nodecursor.next())
            hashtable.put(nodecursor.node(), new NodeWrapper(nodecursor.node()));

        EdgeCursor edgecursor = subgraph1.edges();
        Vector vector = new Vector();
        edgecursor.toFirst();
        for(; edgecursor.ok(); edgecursor.next())
            vector.add(new EdgeWrapper(edgecursor.edge(), (NodeWrapper)hashtable.get(edgecursor.edge().source()), (NodeWrapper)hashtable.get(edgecursor.edge().target())));

        nodeArray = new NodeWrapper[hashtable.size()];
        nodeArray = (NodeWrapper[])hashtable.values().toArray(nodeArray);
        edgeArray = new EdgeWrapper[vector.size()];
        edgeArray = (EdgeWrapper[])vector.toArray(edgeArray);
    }

    EdgeWrapper getEdgeWrapper(Edge edge)
    {
        for(int i = 0; i < edgeArray.length; i++)
            if(edgeArray[i].edge == edge)
                return edgeArray[i];

        return null;
    }

    NodeWrapper getNodeWrapper(Node node)
    {
        for(int i = 0; i < nodeArray.length; i++)
            if(nodeArray[i].node == node)
                return nodeArray[i];

        return null;
    }

    public void setPreferredEdgeLength(Edge edge, double d)
    {

            getEdgeWrapper(edge).length = d;
            }

    public void setDefaultPreferredEdgeLength(double d)
    {
        defaultLength = d;
    }

    public void setIterations(int i)
    {
        iterations = i;
    }

    public void setBounds(Rectangle2D rectangle2d)
    {
        bounds = rectangle2d;
    }

    public void setInertia(Node node, double d)
    {
        getNodeWrapper(node).inertia = d;
    }

    public void setCenterOfMass(Node node, double d, double d1)
    {
        NodeWrapper nodewrapper = getNodeWrapper(node);
        nodewrapper.cOfMDx = d;
        nodewrapper.cOfMDy = d1;
    }

    double length(EdgeWrapper edgewrapper)
    {
        double d = edgewrapper.length;
        if(d <= 0.0D)
            d = defaultLength;
        return d;
    }

    public boolean canLayout(LayoutGraph layoutgraph)
    {
        return true;
    }

    public void doLayout(LayoutGraph layoutgraph)
    {
        doForceDirectedLayout();
    }

    public void doForceDirectedLayout()
    {
        for(int i = 0; i <= iterations; i++)
        {
            for(int j = 0; j < edgeArray.length; j++)
            {
                EdgeWrapper edgewrapper = edgeArray[j];
                double d = (edgewrapper.target.x + edgewrapper.target.cOfMDx) - (edgewrapper.source.x + edgewrapper.source.cOfMDx);
                double d2 = (edgewrapper.target.y + edgewrapper.target.cOfMDy) - (edgewrapper.source.y + edgewrapper.source.cOfMDy);
                double d5 = Math.max(Math.sqrt(distanceSqr(edgewrapper.source, edgewrapper.target)), 0.001D);
                if(d5 > 30D)
                    d5 = Math.sqrt(d * d + d2 * d2);
                double d7 = length(edgewrapper);
                double d11 = (d7 - d5) / (d5 * 2D);
                edgeTension += d11;
                double d14 = d11 * d;
                double d17 = d11 * d2;
                edgewrapper.source.dx -= d14;
                edgewrapper.source.dy -= d17;
                edgewrapper.target.dx += d14;
                edgewrapper.target.dy += d17;
            }

            for(int l = 0; l < nodeArray.length; l++)
            {
                NodeWrapper nodewrapper1 = nodeArray[l];
                if(nodewrapper1.inertia != (1.0D / 0.0D))
                {
                    double d1 = 0.0D;
                    double d4 = 0.0D;
                    for(int j1 = 0; j1 < nodeArray.length; j1++)
                        if(l != j1)
                        {
                            NodeWrapper nodewrapper3 = nodeArray[j1];
                            double d10 = (nodewrapper1.x + nodewrapper1.cOfMDx) - (nodewrapper3.x + nodewrapper3.cOfMDx);
                            double d13 = (nodewrapper1.y + nodewrapper1.cOfMDy) - (nodewrapper3.y + nodewrapper3.cOfMDy);
                            double d16 = distanceSqr(nodewrapper1, nodewrapper3);
                            if(d16 <= 10000D)
                            {
                                if(d16 < 400D)
                                {
                                    d16 = 0.10000000000000001D;
                                    nodewrapper1.dx /= 25D;
                                    nodewrapper1.dy /= 25D;
                                    if(d10 == 0.0D && d13 == 0.0D)
                                    {
                                        d10 = Math.random() * 10D;
                                        d13 = Math.random() * 10D;
                                    }
                                }
                                d1 += d10 / d16;
                                d4 += d13 / d16;
                            }
                        }

                    double d8 = Math.max(Math.sqrt(d1 * d1 + d4 * d4) / 30D, 1.0000000000000001E-005D);
                    nodewrapper1.dx += d1 / d8;
                    nodewrapper1.dy += d4 / d8;
                }
            }

            for(int i1 = 0; i1 < nodeArray.length; i1++)
            {
                NodeWrapper nodewrapper2 = nodeArray[i1];
                double d3 = nodewrapper2.inertia;
                double d6 = Math.max(-5D, Math.min(5D, nodewrapper2.dx / d3));
                double d9 = Math.max(-5D, Math.min(5D, nodewrapper2.dy / d3));
                double d12 = nodewrapper2.x + d6;
                double d15 = nodewrapper2.y + d9;
                if(d12 > bounds.getMaxX())
                    d12 = bounds.getMaxX();
                else
                if(d12 < bounds.getMinX())
                    d12 = bounds.getMinX();
                if(d15 > bounds.getMaxY())
                    d15 = bounds.getMaxY();
                else
                if(d15 < bounds.getMinY())
                    d15 = bounds.getMinY();
                nodewrapper2.x = d12;
                nodewrapper2.y = d15;
                nodewrapper2.dx /= 2D;
                nodewrapper2.dy /= 2D;
            }

            if(i % 41 != 40 && i != iterations)
                continue;
            if(Math.abs((edgeTension - oldTension) / (double)edgeArray.length) < 0.001D || i == iterations)
                break;
            oldTension = edgeTension;
            edgeTension = 0.0D;
        }

        for(int k = 0; k < nodeArray.length; k++)
        {
            NodeWrapper nodewrapper = nodeArray[k];
            g.setCenter(nodewrapper.node, nodewrapper.x, nodewrapper.y);
        }

    }

    double deltaX(double d, double d1, double d2, double d3)
    {
        if(d2 > d1)
            return d2 - d1;
        if(d > d3)
            return d - d3;
        else
            return 0.0D;
    }

    double deltaY(double d, double d1, double d2, double d3)
    {
        if(d2 > d1)
            return d2 - d1;
        if(d > d3)
            return d - d3;
        else
            return 0.0D;
    }

    double distanceSqr(NodeWrapper nodewrapper, NodeWrapper nodewrapper1)
    {
        double d = deltaX(nodewrapper.x - nodewrapper.width / 2D, nodewrapper.x + nodewrapper.width / 2D, nodewrapper1.x - nodewrapper1.width / 2D, nodewrapper1.x + nodewrapper1.width / 2D);
        double d1 = deltaY(nodewrapper.y - nodewrapper.height / 2D, nodewrapper.y + nodewrapper.height / 2D, nodewrapper1.y - nodewrapper1.height / 2D, nodewrapper1.y + nodewrapper1.height / 2D);
        return d * d + d1 * d1;
    }

    protected void mainrun()
    {
    }

    NodeWrapper nodeArray[];
    EdgeWrapper edgeArray[];
    double defaultLength;
    int iterations;
    Rectangle2D bounds;
    LayoutGraph g;
    Subgraph subgraph;
    double edgeTension;
    double oldTension;
}
