// Decompiled by Jad v1.5.8e2. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://kpdus.tripod.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Subgraph.java

package yWays.autolayout.beckerrojas.pathwayLayout;

import java.io.PrintStream;
import java.util.*;
import y.base.*;
import y.geom.YPoint;
import y.layout.*;
import yWays.autolayout.beckerrojas.pathwayLayout.util.EdgeCursorImplementation;
import yWays.autolayout.beckerrojas.pathwayLayout.util.Geometry;
import yWays.autolayout.beckerrojas.pathwayLayout.util.NodeCursorImplementation;

public class Subgraph
{

    public Subgraph(LayoutGraph layoutgraph, NodeCursor nodecursor)
    {
        finishTime = 0;
        discoverTime = 0;
        twinTable = null;
        g = layoutgraph;
        nodeSet = new HashSet();
        setSubgraph(nodecursor);
    }

    public Subgraph(LayoutGraph layoutgraph)
    {
        this(layoutgraph, layoutgraph.nodes());
    }

    public void setSubgraph(NodeCursor nodecursor)
    {
        subGraph = nodecursor;
        nodeSet.clear();
        nodecursor.toFirst();
        for(; nodecursor.ok(); nodecursor.next())
            nodeSet.add(nodecursor.node());

    }

    public NodeCursor getSubgraph()
    {
        return subGraph;
    }

    public NodeCursor nodes()
    {
        return getSubgraph();
    }

    public NodeCursor[] getStronglyConnectedComponents()
    {
        NodeMap nodemap = computeFinishTimes(true);
        reverseEdges(g.edges());
        Node anode[] = new Node[subGraph.size()];
        subGraph.toFirst();
        for(; subGraph.ok(); subGraph.next())
            anode[nodemap.getInt(subGraph.node())] = subGraph.node();

        g.disposeNodeMap(nodemap);
        Vector vector = new Vector();
        NodeMap nodemap1 = g.createNodeMap();
        for(int i = subGraph.size() - 1; i >= 0; i--)
            if(!nodemap1.getBool(anode[i]))
                vector.add(toNodeCursor(DFS(anode[i], nodemap1, null, null, true)));

        g.disposeNodeMap(nodemap1);
        reverseEdges(g.edges());
        NodeCursor anodecursor[] = new NodeCursor[vector.size()];
        for(int j = 0; j < vector.size(); j++)
            anodecursor[j] = (NodeCursor)vector.get(j);

        return anodecursor;
    }

    public NodeCursor[] getConnectedComponents()
    {
        Vector vector = new Vector();
        NodeMap nodemap = g.createNodeMap();
        subGraph.toFirst();
        for(; subGraph.ok(); subGraph.next())
            if(!nodemap.getBool(subGraph.node()))
                vector.add(toNodeCursor(DFS(subGraph.node(), nodemap, null, null, false)));

        g.disposeNodeMap(nodemap);
        NodeCursor anodecursor[] = new NodeCursor[vector.size()];
        for(int i = 0; i < vector.size(); i++)
            anodecursor[i] = (NodeCursor)vector.get(i);

        return anodecursor;
    }

    NodeCursor toNodeCursor(Vector vector)
    {
        return new NodeCursorImplementation(vector);
    }

    public EdgeCursor edges()
    {
        Vector vector = new Vector();
        subGraph.toFirst();
        for(; subGraph.ok(); subGraph.next())
        {
            EdgeCursor edgecursor = subGraph.node().outEdges();
            edgecursor.toFirst();
            for(; edgecursor.ok(); edgecursor.next())
                if(nodeSet.contains(edgecursor.edge().target()))
                    vector.add(edgecursor.edge());

        }

        return new EdgeCursorImplementation(vector);
    }

    public LayoutGraph createTwin()
    {
        twinTable = new Hashtable();
        DefaultLayoutGraph defaultlayoutgraph = new DefaultLayoutGraph();
        subGraph.toFirst();
        for(; subGraph.ok(); subGraph.next())
        {
            Node node = subGraph.node();
            double d = g.getX(node);
            double d1 = g.getY(node);
            double d2 = g.getWidth(node);
            double d3 = g.getHeight(node);
            Node node3 = defaultlayoutgraph.createNode();
            defaultlayoutgraph.setLocation(node3, d, d1);
            defaultlayoutgraph.setSize(node3, d2, d3);
            twinTable.put(node, node3);
        }

        EdgeCursor edgecursor = edges();
        edgecursor.toFirst();
        for(; edgecursor.ok(); edgecursor.next())
        {
            Node node1 = (Node)twinTable.get(edgecursor.edge().source());
            Node node2 = (Node)twinTable.get(edgecursor.edge().target());
            defaultlayoutgraph.createEdge(node1, node2);
        }

        return defaultlayoutgraph;
    }

    public void synchronizeWithTwin(LayoutGraph layoutgraph)
    {
        if(twinTable == null)
            return;
        subGraph.toFirst();
        for(; subGraph.ok(); subGraph.next())
        {
            Node node = subGraph.node();
            Node node1 = (Node)twinTable.get(node);
            double d = layoutgraph.getX(node1);
            double d1 = layoutgraph.getY(node1);
            double d2 = layoutgraph.getWidth(node1);
            double d3 = layoutgraph.getHeight(node1);
            g.setLocation(node, d, d1);
            g.setSize(node, d2, d3);
        }

    }

    public void reverseEdges(EdgeCursor edgecursor)
    {
        edgecursor.toFirst();
        for(; edgecursor.ok(); edgecursor.next())
            g.reverseEdge(edgecursor.edge());

    }

    public NodeMap computeFinishTimes(boolean flag)
    {
        NodeMap nodemap = g.createNodeMap();
        NodeMap nodemap1 = g.createNodeMap();
        resetFinishTime();
        subGraph.toFirst();
        for(; subGraph.ok(); subGraph.next())
            if(!nodemap.getBool(subGraph.node()))
                DFS(subGraph.node(), nodemap, null, nodemap1, flag);

        g.disposeNodeMap(nodemap);
        resetFinishTime();
        return nodemap1;
    }

    protected void resetFinishTime()
    {
        finishTime = 0;
    }

    protected void resetDiscoverTime()
    {
        discoverTime = 0;
    }

    protected Vector DFS(Node node, NodeMap nodemap, NodeMap nodemap1, NodeMap nodemap2, boolean flag)
    {
        nodemap.setBool(node, true);
        Vector vector = new Vector();
        vector.add(node);
        if(nodemap1 != null)
            nodemap1.setInt(node, discoverTime++);
        NodeCursor nodecursor;
        if(flag)
            nodecursor = node.successors();
        else
            nodecursor = node.neighbors();
        for(; nodecursor.ok(); nodecursor.next())
            if(nodeSet.contains(nodecursor.node()) && !nodemap.getBool(nodecursor.node()))
                vector.addAll(DFS(nodecursor.node(), nodemap, nodemap1, nodemap2, flag));

        if(nodemap2 != null)
            nodemap2.setInt(node, finishTime++);
        return vector;
    }

    public NodeCursor[] getAllCycles()
    {
        return getCycles(false);
    }

    protected void cycleDFS(Node node, NodeMap nodemap, HashSet hashset, int i, Stack stack, Hashtable hashtable, boolean flag)
    {
        nodemap.setBool(node, true);
        stack.push(node);
        for(NodeCursor nodecursor = node.successors(); nodecursor.ok(); nodecursor.next())
            if(hashset.contains(nodecursor.node()))
                if(!nodemap.getBool(nodecursor.node()))
                {
                    cycleDFS(nodecursor.node(), nodemap, hashset, i + 1, stack, hashtable, flag);
                } else
                {
                    int j = stack.search(nodecursor.node());
                    NodeCursor nodecursor1 = toNodeCursor(new Vector(stack.subList(stack.size() - j, stack.size())));
                    Object obj;
                    if(flag)
                        obj = new Integer(0);
                    else
                        obj = nodecursor1;
                    if(hashtable.get(obj) == null || ((NodeCursor)hashtable.get(obj)).size() < nodecursor1.size())
                        hashtable.put(obj, nodecursor1);
                }

        nodemap.setBool(node, false);
        stack.pop();
    }

    public NodeCursor getLongestCycle()
    {
        NodeCursor anodecursor[] = getCycles(true);
        if(anodecursor.length == 0)
            return new NodeCursorImplementation(new Vector());
        else
            return anodecursor[0];
    }

    protected NodeCursor[] getCycles(boolean flag)
    {
        long l = System.currentTimeMillis();
        Hashtable hashtable = new Hashtable();
        NodeMap nodemap = g.createNodeMap();
        NodeCursor anodecursor[] = getStronglyConnectedComponents();
        for(int i = 0; i < anodecursor.length; i++)
        {
            NodeCursor nodecursor = anodecursor[i];
            Stack stack = new Stack();
            HashSet hashset = new HashSet();
            nodecursor.toFirst();
            for(; nodecursor.ok(); nodecursor.next())
                hashset.add(nodecursor.node());

            nodecursor.toFirst();
            cycleDFS(nodecursor.node(), nodemap, hashset, 1, stack, hashtable, flag);
        }

        g.disposeNodeMap(nodemap);
        Iterator iterator = hashtable.values().iterator();
        NodeCursor anodecursor1[] = new NodeCursor[hashtable.size()];
        long l1 = System.currentTimeMillis();
        for(int j = 0; j < hashtable.size(); j++)
            anodecursor1[j] = (NodeCursor)iterator.next();

        return anodecursor1;
    }

    public Subgraph invert()
    {
        Vector vector = new Vector();
        for(NodeCursor nodecursor = g.nodes(); nodecursor.ok(); nodecursor.next())
            if(!nodeSet.contains(nodecursor.node()))
                vector.add(nodecursor.node());

        NodeCursorImplementation nodecursorimplementation = new NodeCursorImplementation(vector);
        return new Subgraph(g, nodecursorimplementation);
    }

    public Subgraph union(Subgraph subgraph)
    {
        HashSet hashset = new HashSet(nodeSet);
        subgraph.subGraph.toFirst();
        for(; subgraph.subGraph.ok(); subgraph.subGraph.next())
            hashset.add(subgraph.subGraph.node());

        NodeCursorImplementation nodecursorimplementation = new NodeCursorImplementation(new Vector(hashset));
        return new Subgraph(g, nodecursorimplementation);
    }

    public NodeCursor invertNodeCursor(NodeCursor nodecursor)
    {
        HashSet hashset = new HashSet();
        nodecursor.toFirst();
        for(; nodecursor.ok(); nodecursor.next())
            hashset.add(nodecursor.node());

        Vector vector = new Vector();
        subGraph.toFirst();
        for(; subGraph.ok(); subGraph.next())
            if(!hashset.contains(subGraph.node()))
                vector.add(subGraph.node());

        return new NodeCursorImplementation(vector);
    }

    public NodeCursor unionNodeCursor(NodeCursor nodecursor, NodeCursor nodecursor1)
    {
        HashSet hashset = new HashSet();
        nodecursor.toFirst();
        for(; nodecursor.ok(); nodecursor.next())
            hashset.add(nodecursor.node());

        nodecursor1.toFirst();
        for(; nodecursor1.ok(); nodecursor1.next())
            hashset.add(nodecursor1.node());

        return new NodeCursorImplementation(new Vector(hashset));
    }

    public EdgeCursor outgoingEdges()
    {
        Vector vector = new Vector();
        subGraph.toFirst();
        for(; subGraph.ok(); subGraph.next())
        {
            EdgeCursor edgecursor = subGraph.node().outEdges();
            edgecursor.toFirst();
            for(; edgecursor.ok(); edgecursor.next())
                if(!nodeSet.contains(edgecursor.edge().opposite(subGraph.node())))
                    vector.add(edgecursor.edge());

        }

        return new EdgeCursorImplementation(vector);
    }

    public EdgeCursor incomingEdges()
    {
        Vector vector = new Vector();
        subGraph.toFirst();
        for(; subGraph.ok(); subGraph.next())
        {
            EdgeCursor edgecursor = subGraph.node().inEdges();
            edgecursor.toFirst();
            for(; edgecursor.ok(); edgecursor.next())
                if(!nodeSet.contains(edgecursor.edge().opposite(subGraph.node())))
                    vector.add(edgecursor.edge());

        }

        return new EdgeCursorImplementation(vector);
    }

    public EdgeCursor outgoingEdges(Subgraph subgraph)
    {
        Vector vector = new Vector();
        subGraph.toFirst();
        for(; subGraph.ok(); subGraph.next())
        {
            EdgeCursor edgecursor = subGraph.node().outEdges();
            edgecursor.toFirst();
            for(; edgecursor.ok(); edgecursor.next())
                if(!nodeSet.contains(edgecursor.edge().opposite(subGraph.node())) && subgraph.nodeSet.contains(edgecursor.edge().opposite(subGraph.node())))
                    vector.add(edgecursor.edge());

        }

        return new EdgeCursorImplementation(vector);
    }

    public EdgeCursor incomingEdges(Subgraph subgraph)
    {
        Vector vector = new Vector();
        subGraph.toFirst();
        for(; subGraph.ok(); subGraph.next())
        {
            EdgeCursor edgecursor = subGraph.node().inEdges();
            edgecursor.toFirst();
            for(; edgecursor.ok(); edgecursor.next())
                if(!nodeSet.contains(edgecursor.edge().opposite(subGraph.node())) && subgraph.nodeSet.contains(edgecursor.edge().opposite(subGraph.node())))
                    vector.add(edgecursor.edge());

        }

        return new EdgeCursorImplementation(vector);
    }

    public void moveTo(double d, double d1)
    {
        Geometry geometry = getGeometry();
        double d2 = d - geometry.x;
        double d3 = d1 - geometry.y;
        subGraph.toFirst();
        for(; subGraph.ok(); subGraph.next())
        {
            double d4 = g.getCenterX(subGraph.node());
            double d5 = g.getCenterY(subGraph.node());
            g.setCenter(subGraph.node(), d4 + d2, d5 + d3);
        }

        EdgeCursor edgecursor = edges();
        edgecursor.toFirst();
        for(; edgecursor.ok(); edgecursor.next())
        {
            EdgeLayout edgelayout = g.getEdgeLayout(edgecursor.edge());
            for(int i = 0; i < edgelayout.pointCount(); i++)
            {
                YPoint ypoint = edgelayout.getPoint(i);
                edgelayout.setPoint(i, ypoint.getX() + d2, ypoint.getY() + d3);
            }

        }

    }

    public Geometry getGeometry()
    {
        if(subGraph.size() == 0)
            return new Geometry(0.0D, 0.0D, 0.0D, 0.0D);
        subGraph.toFirst();
        Node node = subGraph.node();
        double d = g.getX(node);
        double d1 = g.getX(node) + g.getWidth(node);
        double d2 = g.getY(node);
        double d3 = g.getY(node) + g.getHeight(node);
        subGraph.toFirst();
        for(; subGraph.ok(); subGraph.next())
        {
            Node node1 = subGraph.node();
            double d4 = g.getX(node1);
            double d6 = g.getX(node1) + g.getWidth(node1);
            if(d4 < d)
                d = d4;
            if(d6 > d1)
                d1 = d6;
            double d8 = g.getY(node1);
            double d10 = g.getY(node1) + g.getHeight(node1);
            if(d8 < d2)
                d2 = d8;
            if(d10 > d3)
                d3 = d10;
        }

        double d5 = d1 - d;
        double d7 = d3 - d2;
        double d9 = d + d5 / 2D;
        double d11 = d2 + d7 / 2D;
        return new Geometry(d9, d11, d5, d7);
    }

    public boolean contains(Node node)
    {
        return nodeSet.contains(node);
    }

    public void printStack(Stack stack)
    {
        System.out.println("Stack: ");
        for(int i = 0; i < stack.size(); i++)
            System.out.print(stack.get(i) + ";");

        System.out.println();
    }

    public String toString()
    {
        String s = "";
        subGraph.toFirst();
        for(; subGraph.ok(); subGraph.next())
            s = s + subGraph.node() + ";";

        return s;
    }

    private int finishTime;
    private int discoverTime;
    private NodeCursor subGraph;
    private LayoutGraph g;
    private HashSet nodeSet;
    Hashtable twinTable;
}
